;*********************** SetMetricScales.lsp **********************************
; J. Akkerman
;
; Metrische schalen NLCS Standards
;
; -Ongebruikte schalen purgen
; -Metric schaallijst toevoegen
; -Alle anno entites de juiste schaal geven
; -Alle viewports cannoscale synchroniseren met de viewport schaal
;
;******************************************************************************
(princ "\nSet Metric Scalelist versie 1.11 ")(princ)

;(setvar "cmdecho" 0)
;(princ "\nAudit: ")
;(vl-cmdf "audit" "y")

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
(defun ScaleListSort ( / as3 ndict dict sce sx sl dl xl)
 (setq dict (dictsearch (namedobjdict) "ACAD_SCALELIST"))
 (setq as3 (assoc 3 dict)	;first as3
	ndict (cdr (member as3 (reverse dict)))
	dict (member as3 dict)
 )
 (while (setq as3 (assoc 3 dict))
    (setq dict (member as3 dict) 
			dl (cons (cdr as3) dl)
          sce (cdr (assoc 350 dict)) ;entity of scale
    )
	(setq sx (/ (cdr (assoc 140 (entget sce))) (cdr (assoc 141 (entget sce)))))
    ;(if (>  sx 1.0) ;cannoscalevalue
       ;(setq xl (cons (cons sx sce) xl))
       (setq sl (cons (cons sx sce) sl))
    ;)
    (setq dict (cdr dict))
 )
 (setq sl (vl-sort sl '(lambda (x y) (> (car x) (car y)))))
 ;(if xl (setq sl (append sl (vl-sort xl '(lambda (x y) (< (car x) (car y)))))))
 (setq dl (acad_strlsort dl))
 (setq n 0)
 (repeat (length dl)
    (setq ndict (cons (cons 3 (nth n dl)) ndict)
          ndict (cons (cons 350 (cdr (nth n sl))) ndict)
          n (1+ n)
    )
 )
 (entmod (reverse ndict))
 (princ)
)
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
;; Get Scalelist list Names and values
(defun GetScaleList (/ csobj n scnam scpap scdwu)
  (setq scnamlist nil scvallist nil schaallst nil)
  (setq csobj (vlax-ename->vla-object (cdar (dictsearch (namedobjdict) "ACAD_SCALELIST"))))
  (setq n 0)
  (repeat (vla-get-count csobj)
	(setq entnm (vlax-vla-object->ename (vlax-invoke-method csobj 'item n)))
	(setq scnam (cdr (assoc 300 (entget entnm)))) ;schaal naam
	(setq scpap (cdr (assoc 140 (entget entnm)))) ;paper units
	(setq scdwu (cdr (assoc 141 (entget entnm)))) ;dwg units
	(setq scval (/ scpap scdwu))
	;(princ scnam) (terpri)
	;(princ (strcat (rtos scpap 2 0) ":" (rtos scdwu 2 0))) (terpri)
	;(command "delay" 200)
	(if (not (wcmatch scnam "*XREF*")) ;skip xref schalen
		(progn
			(setq scnamlist (append (list scnam) scnamlist))
			(setq scvallist (append (list scval) scvallist)) ;waarden om te vergelijken met cannoscalevalue
			(setq schaallst (append (list (list scnam (strcat (rtos scpap 2 0) ":" (rtos scdwu 2 0)))) schaallst))
		)
	)
	(setq n (+ n 1))
  )
)
(defun GetScaleListNames ( )
 (GetScaleList)
 (eval 'scnamlist)
)
(defun GetScaleListValues ( )
 (GetScaleList)
 (eval 'scvallist)
)
(defun GetScaleListDefs ( )
 (GetScaleList)
 (eval 'schaallst)
)
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
(defun ScaleListRename (scn@mlist scv@llist / en enl scname scval1 scval2 schaalwaarde )
 (foreach item (dictsearch (namedobjdict) "ACAD_SCALELIST")
	(if (= 350 (car item))
	 (progn
		(setq 	en (cdr item) 
				enl (entget en)
				scname (cdr(assoc 300 enl)) ;schaal naam
				scval1 (cdr(assoc 140 enl)) ;waarde 1
				scval2 (cdr(assoc 141 enl)) ;waarde 2
				schaalwaarde (/ scval1 scval2) ; scale value
		)
		;(princ (strcat "\nSchaalnaam: " scname " waarde: " (rtos scval1) " = " (rtos scval2) " uitgerekend: " (rtos schaalwaarde 2 4)))
		(if (member schaalwaarde scv@llist)
		 (progn
			(setq scname (nth (vl-position schaalwaarde scv@llist) scn@mlist))
			;(princ (strcat " Nieuwe schaal naam: " scname))
			(if (not(member scname (GetScaleListNames)))
				(progn
					(setq enl (subst (cons 300 scname) (assoc 300 enl) enl))
					(entmod enl)
					;(princ " toegekend. ")
				)
				;(princ " bestaat al! ")
			)
		 )
		)
	 )
	)
 ) ;eind foreach
)
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
;VIEWPORTS Sync VP-scale en Anno-scale, lock
(defun sync_vp (x / vpsc lup scvals)
	(if (= (getvar "cvport") 1)(command "mspace"))
	(setvar "cvport" x)
	(princ (strcat "\nLayout: " (getvar "ctab") "  Viewport " (itoa x) " ..."))
	(if (= (getvar "VPMAXIMIZEDSTATE") 0)	;viewport not maximized
		(progn
			;(cscale) ;corrigeer eventuele kleine afwijkingen
			(if 
				;(= (getvar "cannoscalevalue") (caddr (trans '(0 0 1) 2 3))) ;cannoscale is gelijk aan viewport scale
				(= (rtos(getvar "cannoscalevalue") 2 8) (rtos (caddr(trans '(0 0 1) 2 3)) 2 8)) ;cannoscale is gelijk aan viewport scale
				(princ "Scale OK. ")
			)
			(setq lup (getvar "luprec"))
			(setvar "luprec" 8)
			(setq scvals (mapcar 'rtos (GetScaleListValues))) ;omzetten naar lijst met strings
			(if (member (rtos (caddr (trans '(0 0 1) 2 3)) 2 8) scvals)
				(progn
					(princ " Annoscale en vp-scale synchroniseren.. ")
					(setvar "cmdecho" 0)
					;viewport unlock 
					(vl-cmdf ".mview" "L" "OFF" (ssget "X" (list (cons 0 "VIEWPORT")(cons 69 x)(cons 410 (getvar "ctab")))) "")
					;correctie VP annoschaal:
					;(setvar "cannoscale" (nth (vl-position (caddr (trans '(0 0 1) 2 3)) (GetScaleListValues)) (GetScaleListNames)))
					(setvar "cannoscale" (nth (vl-position (rtos (caddr (trans '(0 0 1) 2 3)) 2 8) scvals) (GetScaleListNames)))
					;viewport lock
					(vl-cmdf ".mview" "L" "ON" (ssget "X" (list (cons 0 "VIEWPORT")(cons 69 x)(cons 410 (getvar "ctab")))) "")
				)
				(princ " No valid viewport scale !! ")
			)
			(setvar "luprec" lup)
		)
		(princ " Not possible while viewport is maximized ")
    ); eind if vpmax
)
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
(DEFUN DO-MSPACE (schdes schval / dd scremlist aa canv nann sann sannu)
;(DEFUN DO-MSPACE (schdes schval / )
	(foreach dd (GetScaleListNames)
		(if (not (member dd schdes)) ;schaalnaam komt niet voor in Infraconsult schaallijst
			(setq scremlist (append (list dd) scremlist)) ;scremlist is lijst met schalen die verwijderd moeten worden
		)
	)
	(if (and scremlist (> (length scremlist) 0))
		(progn
			(setvar "tilemode" 1) 	;goto modelspace
			(setvar "UCSFOLLOW" 0)
			(setvar "cmdecho" 0)
			(vl-cmdf "plan" "w")	;alles horizontaal en binnen beeld zetten
			(vl-cmdf "UCS" "W")		;ucs world actief
			(setq cannu (getvar "cannoscale")) ;actieve schaal voor mspace
			;(setq cannu (nth (vl-position (getvar "cannoscalevalue") schval) schdes)) ;actieve schaal voor mspace
			(setvar "annoallvisible" 0)	;laat alleen curent annoscale objects zien
			(command "delay" 100)
			(foreach aa scremlist
				(setvar "cannoscale" aa)
				(setq canv (getvar "cannoscalevalue"))
				(if (member canv schval)
					(progn
						(setq nann (nth (vl-position canv schval) schdes))
						(princ (strcat "\nCurrent objects annoscale: " aa " > Moet worden: " nann))
						(vl-cmdf "delay" 100)
						;selectieset anno objects current annoscale
						(setq ssann (ssget "C" (getvar "extmin") (getvar"extmax") '((0 . "*TEXT,*LEADER,DIMENSION,HATCH,INSERT,ATTDEF,TOLERANCE"))))
						(if (and ssann (> (sslength ssann) 0))
							(progn
								(vl-cmdf "-OBJECTSCALE" ssann "" "add" nann "") ;schaal toevoegen
								;(setvar "cannoscale" nann)
								(vl-cmdf "-OBJECTSCALE" ssann "" "delete" aa "") ;oude schaal verwijderen
							)
							(princ "\nNO ANNOTATIVE OBJECTS FOUND. ")
						)
					)
					(princ (strcat "\nSchaal " aa " niet in standaard lijst. "))
				)
			)
			(if (member cannu (GetScaleListNames)) (setvar "cannoscale" cannu))
			(setvar "annoallvisible" 1)	;laat alle annoscale objects zien (in modelspace)
		)
		(princ " Geen foute schalen. ")
	)
)
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
(defun c:SetMetricScales ( / lyt vpcur scnaamlijst scwaarde scverh aa verhoud inslist)
;(defun c:SetMetricScales ( / lyt scc aa verhoud inslist)
	(setq lyt (getvar "ctab")) ;save current layout
	(setq vpcur(getvar "cvport")) ;current viewport
	
	(setvar "cmdecho" 0)
	(princ "\nUpdating Scale List: ")

	(cond 
		(	(and (=(getvar "insunits") 4) ;mm
				 (or (wcmatch (strcase(getvar "textstyle")) "*NLCS*")
					 (wcmatch (strcase(getvar "dimstyle")) "*NLCS*")
					 (and (menugroup "InfraCAD") (lspICDIsEventToggleEnabled))
				 )
			)
		 	(setq
			 scnaamlijst (list "MM_1:1" "MM_1:2" "MM_1:2.5" "MM_1:5" "MM_1:10" "MM_1:20" "MM_1:25" "MM_1:50" "MM_1:100" "MM_1:200" "MM_1:250" "MM_1:500" "MM_1:1000" "MM_1:2000" "MM_1:2500" "MM_1:5000" "MM_1:10000")
			 scwaarde (list 1.0 0.5 0.4 0.2 0.1 0.05 0.04 0.02 0.01 0.005 0.004 0.002 0.001 0.0005 0.0004 0.0002 0.0001)
			 scverh (list "1:1" "1:2" "1:2.5" "1:5" "1:10" "1:20" "1:25" "1:50" "1:100" "1:200" "1:250" "1:500" "1:1000" "1:2000" "1:2500" "1:5000""1:10000")
			)
		)
		((=(getvar "insunits") 6) ; m
			(setq
			 scnaamlijst (list "M_1:1" "M_1:2" "M_1:2.5" "M_1:5" "M_1:10" "M_1:20" "M_1:25" "M_1:50" "M_1:100" "M_1:200" "M_1:250" "M_1:500" "M_1:1000" "M_1:1250" "M_1:2000" "M_1:2500" "M_1:5000" "M_1:10000")
			 scwaarde (list 1000.0 500.0 400.0 200.0 100.0 50.0 40.0 20.0 10.0 5.0 4.0 2.0 1.0 0.8 0.5 0.4 0.2 0.1)
			 scverh (list "1000:1" "1000:2" "1000:2.5" "1000:5" "1000:10" "1000:20" "1000:25" "1000:50" "1000:100" "1000:200" "1000:250" "1000:500" "1000:1000" "1000:1250" "1000:2000" "1000:2500" "1000:5000" "1000:10000" "1000:20000" "1000:25000" "1000:50000" "1000:100000" "1000:200000" "1000:250000" "1000:500000")
			)	 
		)
		(	(and	(=(getvar "insunits") 4) ; mm
					(not (wcmatch (strcase(getvar "textstyle")) "*NLCS*"))
			)
			(setq
			 scnaamlijst (list "1:1" "1:2" "1:2.5" "1:5" "1:10" "1:20" "1:25" "1:50" "1:100" "1:200" "1:250" "1:500" "1:1000" "1:2000" "1:2500" "1:5000" "1:10000")
			 scwaarde (list 1.0 0.5 0.4 0.2 0.1 0.05 0.04 0.02 0.01 0.005 0.004 0.002 0.001 0.0005 0.0004 0.0002 0.0001)
			 scverh (list "1:1" "1:2" "1:2.5" "1:5" "1:10" "1:20" "1:25" "1:50" "1:100" "1:200" "1:250" "1:500" "1:1000" "1:2000" "1:2500" "1:5000" "1:10000")
			)
		)
		(T 	
			(setq inslist (list "Unitless" "Inches" "Feet" "Miles" "Millimeters" "Centimeters" "Meters" "Kilometers" "Microinches" "Mils" "Yards" "Angstroms" "Nanometers" "Microns" "Decimeters" "Decameters" "Hectometers" "Gigameters" "Astronomical Units" "Light Years" "Parsecs"))
			(alert (STRCAT " " (CHR 13)
				  " Deze functie is alleen voor gebruik in units meters of millimeters" (CHR 13)
				  " Current Drawing Units: " (nth (getvar "insunits") inslist) (CHR 13)
				  " ")
			)
			(exit)
		)
	)
	;(foreach scc scnaamlijst (princ scc))

	;(if (foreach scc (GetScaleListNames) (member scc scnaamlijst))
		;(PROGN
		;	(PRINC " Schaal namen zijn in orde. ")
		;	(ScaleListSort)
		;)
		;(PROGN
			(vl-cmdf "_.-SCALELISTEDIT" "D" "*" "exit") ;ongebruikte schalen verwijderen
			(setvar "EXPERT" 5)	;Suppresses the prompt, "That name is already in Use, redefine it?"
			(foreach aa scnaamlijst
				(setq verhoud (nth (vl-position aa scnaamlijst) scverh))
				(vl-cmdf "_.-SCALELISTEDIT" "A" aa verhoud "exit")
			)
			(ScaleListRename scnaamlijst scwaarde)
			(princ "\nSorteren op schaalwaarde: ")
			(ScaleListSort)
			(princ "\nSchaal bestaande annotative objecten bijwerken... ")
			(do-mspace scnaamlijst scwaarde) ;set scales for alle anno objects in modelspace
			;schalen voor alle viewports in alle layouts bijwerken
			(princ "\nSchaal Viewports controleren en eventueel aanpassen...")
			(setq rm (getvar "regenmode"))
			(setvar "regenmode" 0)
			(foreach lay (layoutlist)
				(setvar "ctab" lay)
				(vl-cmdf "pspace") (vl-cmdf ".zoom" "e")
				(vl-cmdf "regenall")
				(vl-cmdf "delay" 200)
				(if (> (sslength (setq ssvp (ssget "X" (list(cons 0 "VIEWPORT")(cons 410 lay))))) 1)
					(progn
						(setq vpn 2)
						(repeat (1- (sslength ssvp))
							(sync_vp vpn)
							;(if (member(getvar "cannoscale") scnaamlijst) (sync_vp vpn))
							(setq vpn (+ vpn 1))
						)
					)
					(princ (strcat "\nGeen Viewports op layout: " lay " "))
				)
			) ; end foreach
			(setvar "regenmode" rm)
			(setvar "ctab" lyt)
			(if (and (= (getvar "tilemode") 0) (> (getvar "cvport") 1)) (vl-cmdf "pspace"))
		;) ;EIND PROGN
	;); EIND IF

	(princ "\nMetrische Schaal-Lijst geladen. ")
	(princ)
)
